﻿using System.Diagnostics;
using System.Text.Json.Serialization;

namespace FNZCM2.Abstractions.Models.Fs;

[DebuggerDisplay("F {Id} # {Name} # {Size}")]
public class FileEntry : IFsEntry
{
    [JsonPropertyName("i")] public required long Id { get; init; }

    /// <summary> zero for root </summary>
    [JsonPropertyName("f")] public required long FolderId { get; init; }

    [JsonPropertyName("n")] public required string Name { get; init; }
    [JsonPropertyName("s")] public required long Size { get; init; }
    [JsonPropertyName("t")] public required DateTimeOffset LastChangedTime { get; init; }
}
