﻿using System.Text.Json.Serialization;
using FFmpeg.AutoGen;

namespace FNZCM2.Abstractions.Models.Metadata;

public class PictureInfo
{
    [JsonPropertyName("p")] public required AVPixelFormat PixelFormat { get; init; }
    [JsonPropertyName("w")] public required int Width { get; init; }
    [JsonPropertyName("h")] public required int Height { get; init; }

    public override string ToString()
    {
        return $"{Width}x{Height} {PixelFormat.ToString().Substring("AV_PIX_FMT_".Length)}";
    }
}
