﻿using FFmpeg.AutoGen;
using FNZCM2.Abstractions.Models.Metadata;
using System.Text.Json.Serialization;

namespace FNZCM2.Abstractions.Utility;

public class FfMpegReadResult
{
    public required Dictionary<string, string> MetaData { get; init; }
    public required int? BitRate { get; init; }
    public required int? DurationMs { get; init; }
    public required MediaStream[] Streams { get; init; }


    public class MediaStream
    {
        [JsonPropertyName("t")] public required AVMediaType Type { get; init; }
        [JsonPropertyName("c")] public required AVCodecID Codec { get; init; }
        [JsonPropertyName("a")] public required AudioInfo? AudioInfo { get; init; }
        [JsonPropertyName("v")] public required PictureInfo? PictureInfo { get; init; }
    }
}